"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createGulpCompiler = void 0;
const cross_spawn_1 = __importDefault(require("cross-spawn"));
const path_1 = __importDefault(require("path"));
const cli_shared_utils_1 = require("@xams-framework/cli-shared-utils");
function createGulpCompiler() {
    return (app) => {
        return {
            name: 'cli-plugin-gulp-compiler',
            setup() {
                app.program
                    .command('compiler')
                    .argument('<task>', 'task')
                    .description('use gulp compiler react、ts、less、sass、stylus project')
                    .action((task, options) => {
                    const cwd = process.cwd();
                    const packageDir = path_1.default.dirname(__dirname);
                    const gulpfile = path_1.default.resolve(packageDir, 'gulpfile.js');
                    const gulpfileExt = path_1.default.resolve(process.cwd(), 'gulpfile.js');
                    const args = [
                        task,
                        '--cwd',
                        cwd,
                        '--gulpfile',
                        gulpfile,
                    ];
                    if (cli_shared_utils_1.fse.existsSync(gulpfileExt)) {
                        args.push('--require');
                        args.push(gulpfileExt);
                    }
                    cross_spawn_1.default.sync('gulp', args, { stdio: 'inherit' });
                });
            },
        };
    };
}
exports.createGulpCompiler = createGulpCompiler;
exports.default = createGulpCompiler;
